"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OData = exports.DEFULAT_HEADERS = exports.defaultProxy = exports.S_CONTENT_TYPE = exports.S_X_CSRF_TOKEN = void 0;
const attempt_1 = require("@newdash/newdash/attempt");
const startsWith_1 = require("@newdash/newdash/startsWith");
exports.S_X_CSRF_TOKEN = "x-csrf-token";
exports.S_CONTENT_TYPE = "Content-Type";
const defaultProxy = async (url, init) => {
    const response = await fetch(url, init);
    let content = await response.text();
    if (response.headers?.has(exports.S_CONTENT_TYPE) && (0, startsWith_1.startsWith)(response.headers?.get(exports.S_CONTENT_TYPE), "application/json")) {
        const jsonResult = (0, attempt_1.attempt)(JSON.parse, content);
        // supress error
        if (!(jsonResult instanceof Error)) {
            content = jsonResult;
        }
    }
    return {
        content,
        response,
    };
};
exports.defaultProxy = defaultProxy;
exports.DEFULAT_HEADERS = {
    "Accept": "application/json",
    [exports.S_CONTENT_TYPE]: "application/json"
};
var odata_1 = require("./odata");
Object.defineProperty(exports, "OData", { enumerable: true, get: function () { return odata_1.OData; } });
