import { ODataKeyPredicate } from "./types";
/**
 * ConvertDateFromODataTime (OData V2)
 *
 * @param dateString date string, format is /Date(1512691200000)/
 */
export declare function ConvertDateFromODataTime(dateString: any): Date;
/**
 * FormatODataDateTimedate (OData V2)
 *
 * format date to `/Date(1512691200000)/` format
 */
export declare function FormatODataDateTimedate(date?: Date): string;
export declare function GetAuthorizationPair(user: string, password: string): {
    Authorization: string;
};
export declare class SearchParams {
    private _store;
    append(key: string, value: string): void;
    putAll(param: SearchParams): void;
    toString(): string;
}
/**
 * convert the odata key predicate object/value to string
 *
 * @param key
 *
 * @example
 *
 * ```ts
 * formatId(1) // => String('(1)')
 * formatId({UUID:'xxx'}) // => String('(UUID='xxx')')
 * ```
 */
export declare function formatId(key: ODataKeyPredicate): string;
